/***************************************************************************
                          brain.h  -  description
                             -------------------
    begin                : Thu Feb 12 2004
    copyright            : (C) 2004 by Gene Ruebsamen
    email                : gene@localhost.localdomain
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifndef BRAIN_H
#define BRAIN_H

#include <vector>

using std::vector;

template <class T>
class Brain
{
public:
	virtual ~Brain() { };
	virtual vector<T> getWeights() const = 0;
	virtual unsigned int getGeneSize() const = 0;
	virtual void putWeights(vector<T> &) = 0;
	virtual vector<T> activate(vector<T> &input) = 0;
};

#endif

